program obj3_11;

uses crt, meusobj2;

const
  max = 3;

type

  PtRegElemento = ^RegElemento;

  RegElemento = record
    nome : string[1];
    peso : integer;
    idade: integer;
    end;


type
  lista = object
    itemlista : array[1..max] of PtRegElemento;
    contador  : 0..max;
    procedure inicia;
    function cheia : boolean;
    function vazia : boolean;
  end;

  pilha = object (lista)
    procedure push(var item:PtRegElemento);
    procedure pop(var item:PtRegElemento);
  end;

{ metodos do objeto lista }

procedure lista.inicia;
  var
    cont : integer;

  begin
    clrscr;
    for cont := 1 to max do
      begin
        new(itemlista[cont]);
        itemlista[cont]^.nome := espaco;
      end;
    contador := 0
  end;

function lista.cheia : boolean;
  begin
    if contador = max
      then
        cheia := true
      else
        cheia := false
  end;

function lista.vazia : boolean;
  begin
    vazia := (contador = 0)
  end;

{ metodos para objeto pilha  }

procedure pilha.push(var item:PtRegElemento);
  begin
    if cheia
      then
        begin
          item := nil;
          writeln(' pilha cheia.');
          exit
        end
      else
        begin
          contador := contador + 1;
          itemlista[contador] := item;
        end
  end;

procedure pilha.pop(var item:PtRegElemento);
  begin
    if vazia
       then
        begin
          item := nil;;
          writeln(' Pilha vazia.');
          exit
        end
      else
        begin
          item := itemlista[contador];
          contador := contador - 1
        end
  end;

{ declaracao de variaveis  }

var
  listacar : pilha;
  key      : char;
  fim      : boolean;
  pp       : PtRegElemento;

{ procedimentos nao orientados a objetos  }
(*
procedure PushNaPilha(var listacar:pilha);
  var
    item     : PtRegElemento;
    cont     : integer;
  begin
        new(item);
        write(' Digite nome:10, peso:2, e idade:2 : ');
        readln(item^.nome,item^.peso,item^.idade);
        Listacar.push(item);
        writeln;
        if item = nil
         then
          fim := true
         else
          dispose(item)
  end;

procedure PopDaPilha(var listacar:pilha);
  var
    cont     : integer;
    item     :PtRegElemento;
  begin
    clrscr;
    writeln;
    writeln(' Elemento retirado da pilha : ');
    new(item);
    listacar.pop(item);
    if item <> nil
     then
       begin
         writeln(item^.nome, espaco,item^.peso,espaco,item^.idade);
         dispose(item);
       end
  end;
*)
{ Programa principal  }
(*
begin
  listacar.inicia;
  fim := false;
  repeat
    writeln;
    writeln(' Digite i para incuir, e para excluir, f para finalizar ');
    key := readkey;
    case key of
      'i' :  PushnaPilha(listacar);
      'e' :  PopDapilha(listacar);
      'f' :  fim := true;
      else
         writeln(' Digite i para incuir, e para excluir, f para finalizar ');
      end;
   until fim;
  key := readkey
end.*)


procedure PushNaPilha(var listacar:pilha);
  var
    novoitem : char;
    cont : integer;
  begin
   
    for cont := 1 to max do
      begin
        new(pp);
        write(' Digite nome:10, peso:2, e idade:2 : ');
        readln(pp^.nome,pp^.peso,pp^.idade);
        Listacar.push(pp);
        writeln
      end
  end;

procedure PopDaPilha(var listacar:pilha);
  var
    cont     : integer;
    item     :PtRegElemento;
  begin
    clrscr;
    writeln('  Os elementos da pilha saem em ordem LIFO.');
    writeln;
    writeln(' Elementos retirados da pilha : ');
    new(item);
    for cont := 1 to max do
      begin
        listacar.pop(item);
        writeln(item^.nome, espaco,item^.peso,espaco,item^.idade)
      end
  end;

{ Programa principal  }

begin
  listacar.inicia;
  PushnaPilha(listacar);
  PopDapilha(listacar);
  key := readkey
end.
