program obj3_15;

uses crt;

const
  max = 3;
  espaco = #32;

type

  PtRegElemento = ^RegElemento;

  RegElemento = object
    dados : record
       nome : string[1];
       peso : integer;
       idade: integer;
      end;
    flink   : PtRegElemento;
    procedure inicia;
    procedure entrada(var item:PtRegElemento);
    procedure saida  (    item:PtRegElemento);
    end;


type
  lista = object
    topo,p    : PtRegElemento;
    contador  : 0..max;
    procedure inicia;
    function cheia : boolean;
    function vazia : boolean;
  end;

  pilha = object (lista)
    procedure push(var item:PtRegElemento;var erro:byte);
    procedure pop (var item:PtRegElemento;var erro:byte);
  end;

{ metodos do objeto lista }

procedure lista.inicia;
  var
    cont : integer;

  begin
    clrscr;
    topo := nil;
    contador := 0
  end;

function lista.cheia : boolean;
  begin
    if contador = max
      then
        cheia := true
      else
        cheia := false
  end;

function lista.vazia : boolean;
  begin
    vazia := (contador = 0)
  end;

{ metodos para objeto pilha  }

procedure pilha.push(var item:PtRegElemento;var erro:byte);
  begin
    if cheia
      then
        begin
          erro := 2;
          writeln(' pilha cheia.');
        end
      else
        begin
          contador := contador + 1;
          item^.flink := topo;
          topo     := item;
        end
  end;

procedure pilha.pop(var item:PtRegElemento;var erro:byte);
  begin
    if vazia
       then
        begin
          erro := 1;
          writeln(' Pilha vazia.');
        end
      else
        begin
          item := topo;
          item^.flink := nil;
          topo := topo^.flink;
          contador := contador - 1
        end
  end;

{ metodos para o objeto RegElemento }

Procedure RegElemento.inicia;
begin
  dados.nome := espaco;
  dados.peso := 0;
  dados.idade:= 0;
end;

Procedure RegElemento.Entrada(var item:PtRegElemento);
  begin
        write(' Digite nome:10, peso:2, e idade:2 : ');
        readln(item^.dados.nome,item^.dados.peso,item^.dados.idade);
  end;


Procedure RegElemento.Saida(item:PtRegElemento);
begin
  writeln(item^.dados.nome, espaco,item^.dados.peso,espaco,
          item^.dados.idade);
end;

{ declaracao de variaveis  }

var
  listacar : pilha;
  Estrutura: RegElemento;
  key      : char;
  fim      : boolean;
  erro     : byte;


{ procedimentos nao orientados a objetos  }

procedure PushNaPilha(var listacar:pilha;var erro:byte);
  var
    item     : PtRegElemento;
  begin
        new(item);
        Estrutura.entrada(item);
        Listacar.push(item,erro);
  end;

procedure PopDaPilha(var listacar:pilha;var erro:byte);
  var
    item     :PtRegElemento;
  begin
    writeln;
    writeln(' Elemento retirado da pilha : ');
    listacar.pop(item,erro);
    if erro = 0
     then
       begin
         Estrutura.Saida(item);
        { dispose(item);  }
       end
  end;

{ Programa principal  }

begin
  listacar.inicia;
  fim := false;
  repeat
    erro := 0;
    writeln;
    writeln(' Digite i para incuir, e para excluir, f para finalizar ');
    key := readkey;
    case key of
      'i' :  PushNaPilha(listacar,erro);
      'e' :  PopDapilha(listacar,erro);
      'f' :  fim := true;
      else
         writeln(' Digite i para incuir, e para excluir, f para finalizar ');
      end;
      if erro > 1
        then
          fim := true
   until fim;
  key := readkey
end.

