program obj3_16;

uses crt;

const
  max = 3;
  espaco = #32;

type

  PtRegElemento = ^RegElemento;

  RegElemento = object
    nome : string[1];
    peso : integer;
    idade: integer;
    procedure inicia;
    procedure entrada(var item:PtRegElemento);
    procedure saida  (    item:PtRegElemento);
    end;


type
  lista = object
    itemlista : array[1..max] of PtRegElemento;
    contador  : 0..max;
    procedure inicia;
    function cheia : boolean;
    function vazia : boolean;
  end;

  pilha = object (lista)
    procedure push(var item:PtRegElemento;var erro:byte);
    procedure pop (var item:PtRegElemento;var erro:byte);
  end;

  fila = object (lista)
    frente     : integer;
    retaguarda : integer;
    procedure inicia;
    procedure InclueNaRetaguarda(var item : PtRegElemento; var erro : byte);
    procedure ExcluiDaFrente(var item : PtRegElemento; var erro : byte);
  end;

{ metodos do objeto lista }

procedure lista.inicia;
  var
    cont : integer;

  begin
    clrscr;
    for cont := 1 to max do
      begin
        new(itemlista[cont]);
      end;
    contador := 0
  end;

function lista.cheia : boolean;
  begin
    if contador = max
      then
        cheia := true
      else
        cheia := false
  end;

function lista.vazia : boolean;
  begin
    vazia := (contador = 0)
  end;

{ metodos para objeto pilha  }

procedure pilha.push(var item:PtRegElemento;var erro:byte);
  begin
    if cheia
      then
        begin
          erro := 2;
          writeln(' pilha cheia.');
        end
      else
        begin
          contador := contador + 1;
          itemlista[contador] := item;
        end
  end;

procedure pilha.pop(var item:PtRegElemento;var erro:byte);
  begin
    if vazia
       then
        begin
          erro := 1;
          writeln(' Pilha vazia.');
        end
      else
        begin
          item := itemlista[contador];
          itemlista[contador] := nil;
          contador := contador - 1
        end
  end;

{ metodos para o objeto fila }

procedure fila.inicia;
begin
  frente      :=  1;
  retaguarda  :=  1;
end;

procedure fila.InclueNaRetaguarda(var item : PtRegElemento ; var erro : byte);
  begin
     if cheia
      then
        begin
          erro := 4;
          writeln(' fila cheia.');
        end
      else
        begin
          if retaguarda = max
            then
              retaguarda := 1
            else
              retaguarda := retaguarda + 1;
          itemlista[retaguarda] := item;
               writeln(' enfileirou');
          contador := contador + 1
        end
  end;

procedure fila.ExcluiDaFrente(var item : PtRegElemento; var erro : byte);
  begin
    if vazia
       then
        begin
          erro := 1;
          writeln(' fila vazia.');
        end
      else
        begin
          if frente = max
            then
              frente := 1
            else
              frente := frente + 1;
          item := itemlista[frente];
      {    itemlista[frente] := nil;    }
          contador := contador - 1
        end
  end;

{ metodos para o objeto RegElemento }

Procedure RegElemento.inicia;
begin
  nome := espaco;
  peso := 0;
  idade:= 0;
end;

Procedure RegElemento.Entrada(var item:PtRegElemento);
  begin
        write(' Digite nome:10, peso:2, e idade:2 : ');
        readln(item^.nome,item^.peso,item^.idade);
  end;


Procedure RegElemento.Saida(item:PtRegElemento);
begin
  writeln(item^.nome, espaco,item^.peso,espaco,item^.idade);
end;

{ declaracao de variaveis  }

var
  listacar : pilha;
  Estrutura: RegElemento;
  key      : char;
  fim      : boolean;
  erro     : byte;
  fila_1   : fila;


{ procedimentos nao orientados a objetos  }

procedure PushNaPilha(var listacar:pilha;var erro:byte);
  var
    item     : PtRegElemento;
  begin
        new(item);
        Estrutura.entrada(item);
        Listacar.push(item,erro);
  end;

procedure PopDaPilha(var listacar:pilha;var erro:byte);
  var
    item     :PtRegElemento;
  begin
    writeln;
    writeln(' Elemento retirado da pilha : ');
    listacar.pop(item,erro);
    if erro = 0
     then
       begin
         Estrutura.Saida(item);
         dispose(item);
       end
  end;

procedure Enfileira(fila_1:fila;var erro:byte);
  var
    item     : PtRegElemento;
  begin
        new(item);
        Estrutura.entrada(item);
        fila_1.InclueNaRetaguarda(item,erro);
  end;

procedure Desenfileira(var fila_1:fila;var erro:byte);
  var
    item     :PtRegElemento;
  begin
    writeln;
    writeln(' Elemento retirado da fila : ');
    fila_1.ExcluiDaFrente(item,erro);
    if erro = 0
     then
       begin
         Estrutura.Saida(item);
{         dispose(item);   }
       end
  end;

{ Programa principal  }

begin
  listacar.inicia;
  fila_1.inicia;
  clrscr;
  writeln(' Para usar pilha tecle p; para usar fila tecle f ');
  key := readkey;
  fim := false;

  if key = 'p' then
  begin
  repeat
    erro := 0;
    writeln;
    writeln(' Digite i para incuir, e para excluir, f para finalizar ');
    key := readkey;
    case key of
      'i' :  PushNaPilha(listacar,erro);
      'e' :  PopDapilha(listacar,erro);
      'f' :  fim := true;
      else
         writeln(' Digite i para incuir, e para excluir, f para finalizar ');
      end;
      if erro > 1
        then
          fim := true
   until fim;
  key := readkey;
  end

  else

   begin
  repeat
    erro := 0;
    writeln;
    writeln(' Digite i para incuir, e para excluir, f para finalizar ');
    key := readkey;
    case key of
      'i' :  Enfileira(fila_1,erro);
      'e' :  Desenfileira(fila_1,erro);
      'f' :  fim := true;
      else
         writeln(' Digite i para incuir, e para excluir, f para finalizar ');
      end;
      if erro > 1
        then
          fim := true
   until fim;
  key := readkey;
  end
end.

